"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const puppeteer_1 = __importDefault(require("puppeteer"));
function wait(ms) {
    return new Promise((resolve) => setTimeout(() => resolve(), ms));
}
function retrieveRealHTML(url, outputFilePath) {
    return __awaiter(this, void 0, void 0, function* () {
        const browser = yield puppeteer_1.default.launch();
        const page = yield browser.newPage();
        // go to desired url
        yield page.goto(url, { waitUntil: "networkidle0" });
        // set viewport to machine
        yield page.setViewport({ width: 0, height: 0 });
        // scroll to bottom of page smoothly
        yield page.evaluate("window.scrollTo({top: document.body.scrollHeight, left: 0, behavior: 'smooth'})");
        // wait for quite a while for any lazyloaded / API images etc to load
        yield wait(15000);
        // get html
        const html = yield page.content();
        // write html to file
        fs_1.default.writeFile(outputFilePath, html, function (error) {
            console.log(error);
        });
        // close the puppeteer browser
        yield browser.close();
        // return the html string
        return html;
    });
}
exports.retrieveRealHTML = retrieveRealHTML;
